# dropdown_type.h File Reference

Types related to the drop down widget. More...

`#include "../window_type.h"`
`#include <list>`

Go to the source code of this file.

## Data Structures

class | DropDownListItem
| Base list item class from which others are derived. More...
class | DropDownListStringItem
| Common string list item. More...
class | DropDownListParamStringItem
| String list item with parameters. More...
class | DropDownListCharStringItem
| List item containing a C char string. More...

## Typedefs

typedef std::list < DropDownListItem * > | DropDownList
| A drop down list is a collection of drop down list items.

## Functions

void | ShowDropDownList (Window *w, DropDownList *list, int selected, int button, uint width=0, bool auto_width=false, bool instant_close=false)
| Show a drop down list.

## Detailed Description

Types related to the drop down widget.

Definition in file dropdown_type.h.

## Function Documentation

void ShowDropDownList | ( | Window * | w,
|  | DropDownList * | list,
|  | int | selected,
|  | int | button,
|  | uint | width = `0`,
|  | bool | auto_width = `false`,
|  | bool | instant_close = `false` |
| ) |  |  |

Show a drop down list.

Parameters:

  | w | Parent window for the list.
  | list | Prepopulated DropDownList. Will be deleted when the list is closed.
  | selected | The initially selected list item.
  | button | The widget within the parent window that is used to determine the list's location.
  | width | Override the width determined by the selected widget.
  | auto_width | Maximum width is determined by the widest item in the list.
  | instant_close | Set to true if releasing mouse button should close the list regardless of where the cursor is.

Definition at line 237 of file dropdown.cpp.

References Widget::bottom, Widget::colour, DeleteWindowById(), FindWindowById(), Window::height, DropDownListItem::Height(), Window::InvalidateWidget(), Window::left, Widget::left, Window::LowerWidget(), max(), Widget::right, Widget::top, Window::top, WDF_DEF_WIDGET, Window::widget, DropDownListItem::Width(), Window::window_class, and Window::window_number.

Referenced by NewGRFWindow::OnClick(), ReplaceVehicleWindow::OnClick(), PopupMainCompanyToolbMenu(), PopupMainToolbMenu(), ShowGroupActionDropdown(), and ShowTownnameDropdown().